# appleseed [![Build Status](https://travis-ci.org/appleseedhq/appleseed.svg?branch=master)](https://travis-ci.org/appleseedhq/appleseed) [![Slack](https://slackin-pohcdrcgcs.now.sh/badge.svg)](https://slackin-pohcdrcgcs.now.sh/)

![Japanese Classroom, by Blender Swap’s user NovaZeeke](https://appleseedhq.net/img/renders/classroom.jpg)

## Overview

appleseed is an open source, physically-based global illumination rendering engine primarily designed for animation and visual effects.

appleseed is actively developed by a small, international team of talented volunteers from the animation and VFX industry. Its core mission is to provide individuals and small studios with a complete, reliable, fully open rendering package.

Over the years appleseed has been used on several projects including [TV documentaries](https://vimeo.com/81199785), ads, promotional videos and [an animation short](http://www.fetchaveryshortfilm.com/).

appleseed is available as a portable C++ library with C++ and Python APIs, as a set of standalone applications for Windows, Linux and macOS, and as native plugins for content creation applications. [Downloads &rarr;](https://appleseedhq.net/download.html)

[Read more&hellip;](https://appleseedhq.net/about.html)

## On the Web

* Home: [appleseedhq.net](https://appleseedhq.net/)
* Twitter: [twitter.com/appleseedhq](https://twitter.com/appleseedhq)
* Vimeo: [vimeo.com/appleseedhq](https://vimeo.com/appleseedhq)
* User Forum: [forum.appleseedhq.net](https://forum.appleseedhq.net/)
* Developers' Slack: [appleseedhq.slack.com](https://slackin-pohcdrcgcs.now.sh/)

## Contributing

* [How to build appleseed from source](https://github.com/appleseedhq/appleseed/wiki/Building-appleseed)
* [Coding philosophy and guidelines](https://github.com/appleseedhq/appleseed/wiki/Coding-Philosophy-and-Guidelines)
* [Detailed projects ideas](https://github.com/appleseedhq/appleseed/wiki/List-of-Project-ideas-for-GSoC-2017)
* [Developer and contributor wiki](https://github.com/appleseedhq/appleseed/wiki)

## Related Projects

* [appleseed for Autodesk® Maya®](https://github.com/appleseedhq/appleseed-maya)
* [appleseed for Autodesk® 3ds Max®](https://github.com/appleseedhq/appleseed-max)
* [appleseed for Blender](https://github.com/appleseedhq/blenderseed)

## License

appleseed and its accompanying software is released under the [MIT license](https://en.wikipedia.org/wiki/MIT_License).

© 2010-2017 The appleseedhq Organization
